#include <malloc.h>
#include <ctype.h>
#define NOMACROS
#include "inbuf.h"

void
clearbuf(struct inbuf *db)
{
     if(db->buf)
	  free(db->buf);
     db->buf = 0;
     db->bufndx = 0;
     db->bufsize = 0;
}

void
resetbuf(struct inbuf *db)
{
     db->bufndx = 0;
}

void
addstr(struct inbuf *db, char *s)
{
     if(!db->buf){
	  db->bufndx = 0;
	  db->bufsize = 16;
	  db->buf = (char *)malloc(db->bufsize);
     }

     for(;*s;s++){
	  if(db->bufndx == db->bufsize){
	       db->bufsize <<= 1;
	       db->buf = (char *)realloc(db->buf, db->bufsize);
	  }
	  db->buf[db->bufndx++] = *s;
     }
}

#define LEFT 0
#define RIGHT 1

void
addstrf(struct inbuf *db, char *fmt, char *s)
{
     fmt++; /* skip over '%' */
     if(*fmt == 's'){
	  addstr(db, s);
     }
     else {
	  int min=0, max = 9999;
	  int just = RIGHT;
	  
	  if(*fmt == '-'){
	       just = LEFT;
	       fmt++;
	  }
	  if(isdigit(*fmt)){
	       while(isdigit(*fmt)){
		    min = (min*10)+(*fmt-'0');
		    fmt++;
	       }
	  }
	  if(*fmt == '.'){
	       fmt++;
	       if(isdigit(*fmt)){
		    max = 0;
		    while(isdigit(*fmt)){
			 max = (max*10)+(*fmt-'0');
			 fmt++;
		    }
	       }
	       else
		    max=min;
	  }
	  if(!db->buf || !db->bufsize){
	       db->bufndx = 0;
	       db->bufsize = 16;
	       db->buf = (char *)malloc(db->bufsize);
	  }

	  if(just == LEFT){
	       int space, cpycnt;

	       cpycnt = strlen(s);
	       if(cpycnt > max)
		    cpycnt = max;

	       space = cpycnt < min ? min : cpycnt;
	       if(db->bufndx + space >= db->bufsize){
		    while(db->bufndx+space >= db->bufsize)
			 db->bufsize <<= 1;
		    db->buf = (char *)realloc(db->buf, db->bufsize);
	       }
	       for(;*s && max;s++,max--,min--){
		    db->buf[db->bufndx++] = *s;
	       }
	       for(;min>0;min--)
		    db->buf[db->bufndx++] = ' ';
	  }
	  else {
	       int space, cpycnt, ndx;
	       char *cp;

	       cpycnt = strlen(s);
	       if(cpycnt > max)
		    cpycnt = max;
	       cp = s+(cpycnt-1);

	       space = cpycnt < min ? min : cpycnt;
	       if(db->bufndx + space >= db->bufsize){
		    while(db->bufndx+space >= db->bufsize)
			 db->bufsize <<= 1;
		    db->buf = (char *)realloc(db->buf, db->bufsize);
	       }
	       ndx = space-1;
	       for(;cp >= s && max;cp--,ndx--,max--,min--){
		    db->buf[db->bufndx+ndx] = *cp;
	       }
	       for(;min>0;min--,ndx--)
		    db->buf[db->bufndx+ndx] = ' ';
	       db->bufndx += space;
	  }
     }
}


void
addchar(struct inbuf *db, char c)
{
     if(!db->buf){
	  db->bufndx = 0;
	  db->bufsize = 16;
	  db->buf = (char *)malloc(db->bufsize);
     }

     if(db->bufndx == db->bufsize){
	  db->bufsize <<= 1;
	  db->buf = (char *)realloc(db->buf, db->bufsize);
     }
     db->buf[db->bufndx++] = c;
}
